package com.ruoyi.system.mapper;

import java.time.LocalDate;
import java.util.Date;
import java.util.List;
import com.ruoyi.system.domain.ReportDetail;
import org.apache.ibatis.annotations.Param;

/**
 * 报告信息Mapper接口
 * 
 * @author boman
 * @date 2021-12-27
 */
public interface ReportDetailMapper 
{
    /**
     * 查询报告信息
     * 
     * @param reportId 报告信息主键
     * @return 报告信息
     */
    public ReportDetail selectReportDetailByReportId(Long reportId);

    /**
     * 查询报告信息列表
     * 
     * @param reportDetail 报告信息
     * @return 报告信息集合
     */
    public List<ReportDetail> selectReportDetailList(ReportDetail reportDetail);

    /**
     * 新增报告信息
     * 
     * @param reportDetail 报告信息
     * @return 结果
     */
    public int insertReportDetail(ReportDetail reportDetail);

    /**
     * 修改报告信息
     * 
     * @param reportDetail 报告信息
     * @return 结果
     */
    public int updateReportDetail(ReportDetail reportDetail);

    /**
     * 删除报告信息
     * 
     * @param reportId 报告信息主键
     * @return 结果
     */
    public int deleteReportDetailByReportId(Long reportId);

    /**
     * 批量删除报告信息
     * 
     * @param reportIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteReportDetailByReportIds(Long[] reportIds);


    /**
     * 校验报告编号唯一性
     * @param reportNumber
     * @return
     */
    public ReportDetail checkReportNumberUnique(String reportNumber);

    /**
     * 根据报告编号查询详情信息
     * @param reportNumber
     * @return
     */
    ReportDetail selectReportDetailByReportNumber(String reportNumber);

    /**
     * 根据报告编号查询详情信息中的详细查询
     * @param reportNumber
     * @return
     */
    ReportDetail selectReportDetailByReportNumberDetail(String reportNumber);

    /**
     * 查询报告生成次数
     * @return
     */
    int selectReportDetailCount(@Param("today") LocalDate today,@Param("startTime") LocalDate startTime, @Param("endTime") LocalDate endTime);

}
